/*
 * File: MyGame.js 
 * This is the logic of our game. For now, this is very simple.
 */
/*jslint node: true, vars: true */
/*global gEngine, SimpleShader,  */
/* find out more about jslint: http://www.jslint.com/help.html */

"use strict";  // Operate in Strict mode such that variables must be declared before used!

function ClassExample() {
    this.mConstColorShader = new SimpleShader( // 
        "src/GLSLShaders/SimpleVS.glsl",       // 
        "src/GLSLShaders/SimpleFS.glsl");      // 
    this.mAllObjects = [];
}

ClassExample.prototype.draw = function (camera) {

    // Step E: Clear the canvas
    gEngine.Core.clearCanvas([0.9, 0.9, 0.9, 1]);        // Clear the canvas

    // Step F: Starts the drawing by activating the camera
    camera.setupViewProjection();

    var i = 0;
    for (i = 0; i < this.mAllObjects.length; i++)
        this.mAllObjects[i].draw(camera);
};

ClassExample.prototype.createCustomMesh = function (meshInString) {
    var m = new MeshRenderable(this.mConstColorShader, meshInString);
    this.mAllObjects.push(m);
    return this.mAllObjects[this.mAllObjects.length-1].getXform();
};